%global httpd_pkg_cache_dir /var/cache/httpd/mod_auth_openidc

Summary:    OpenID Connect auth module for Apache HTTP Server
Name:       mod_auth_openidc
Version:    2.4.11.2
Release:    9%{?dist}
License:    ASL 2.0
URL:        https://github.com/zmartzone/mod_auth_openidc
Source0:    %{url}/archive/v%{version}.tar.gz

Patch0001:	0001-fix-CVE-2022-23527-for-release-2.4.11.2.patch
Patch0002:	0002-fix-CVE-2023-28625-for-release-2.4.11.2.patch
Patch0003:      0003-fix-CVE-2024-24814-for-release-2.4.11.2.patch

BuildRequires: make gcc httpd-devel openssl-devel curl-devel jansson-devel
BuildRequires: pcre2-devel autoconf automake cjose-devel jq-devel libuuid-devel hiredis-devel
Requires:    httpd-mmn = %{_httpd_mmn}

%description
This module enables an Apache 2.x web server to operate as an OpenID Connect Relying Party and/or
OAuth 2.0 Resource Server.

%prep
%autosetup -n %{name}-%{version} -p1

%build
export MODULES_DIR=%{_httpd_moddir}
export APXS2_OPTS='-S LIBEXECDIR=${MODULES_DIR}'
autoreconf -vfi
%configure \
    --with-jq=/usr/lib64/ \
    --with-hiredis \
    --with-apxs2=%{_httpd_apxs} \
    %{nil}

%{make_build}

%install
mkdir -p %{buildroot}%{_httpd_moddir}
%make_install MODULES_DIR=%{buildroot}%{_httpd_moddir}

install -m 755 -d %{buildroot}%{_httpd_modconfdir}
echo 'LoadModule auth_openidc_module modules/mod_auth_openidc.so' > \
    %{buildroot}%{_httpd_modconfdir}/10-auth_openidc.conf

install -Dm 644 auth_openidc.conf %{buildroot}%{_httpd_confdir}/auth_openidc.conf
sed -i 's!/var/cache/apache2/!/var/cache/httpd/!' %{buildroot}%{_httpd_confdir}/auth_openidc.conf
install -m 700 -d %{buildroot}%{httpd_pkg_cache_dir}
install -m 700 -d %{buildroot}%{httpd_pkg_cache_dir}/metadata
install -m 700 -d %{buildroot}%{httpd_pkg_cache_dir}/cache

%files
%license LICENSE.txt
%doc ChangeLog AUTHORS README.md
%config(noreplace) %{_httpd_modconfdir}/10-auth_openidc.conf
%config(noreplace) %{_httpd_confdir}/auth_openidc.conf
%{_httpd_moddir}/mod_auth_openidc.so
%dir %attr(0700, apache, apache) %{httpd_pkg_cache_dir}
%dir %attr(0700, apache, apache) %{httpd_pkg_cache_dir}/metadata
%dir %attr(0700, apache, apache) %{httpd_pkg_cache_dir}/cache

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.11.2-9
- Rebuilt for loongarch release

* Tue Mar 19 2024 Rebuild Robot <rebot@opencloudos.org> - 2.4.11.2-8
- Rebuilt for jansson

* Thu Mar 7 2024 Doris Chao <doriscchao@tencent.com> - 2.4.11.2-7
- Add patches to fix CVE-2022-23527,CVE-2023-28625,CVE-2024-24814

* Thu Oct 12 2023 Miaojun Dong <zoedong@tencent.com> - 2.4.11.2-6
- Rebuild for curl-8.4.0

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.11.2-5
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Jul 19 2023 cunshunxia <cunshunxia@tencent.com> - 2.4.11.2-4
- Rebuilt for httpd 2.4.57

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.11.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.11.2-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 22 2023 Shuo Wang <abushwang@tencent.com> - 2.4.11.2-1
- initial build
